/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail;

import org.jboss.mail.message.*;

/**
 * Mail Listeners receive each message for processing.  
 * @author Andrew C. Oliver
 */
public interface MailListener {
   /**
    * handle a message. 
    *
    * @param msg the message object.
    * @return the message containing what could not be handled by this listener, null if 
    * the whole message was consumed
    * 
    *
    */
   public Message send(Message msg);
}
