/*
 * Created on Aug 6, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.jboss.mail;

import java.io.IOException;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.nio.ByteBuffer;
import java.nio.channels.Channel;
import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.ServerSocketChannel;
import java.nio.channels.SocketChannel;
import java.util.Iterator;
import java.util.Set;

/**
 * @author andrewoliver
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class NIOServer extends Server {

	/**
	 * @param port
	 * @param backlog
	 * @param address
	 * @param protocol
	 * @param timeout
	 * @param life
	 */
	public NIOServer(int port, int backlog, String address, String protocol,
			long timeout, long life) {
		super(port, backlog, address, protocol, timeout, life);
		// TODO Auto-generated constructor stub
	}

	/**
	 * 
	 */
	public NIOServer() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	public void run() {
		try {
			InetSocketAddress isa = new InetSocketAddress( InetAddress.getByName(this.address), this.port );
			ServerSocketChannel channel = ServerSocketChannel.open();
			channel.configureBlocking( false );
			channel.socket().bind( isa ); 
			Selector selector = Selector.open();
			channel.register(selector, SelectionKey.OP_ACCEPT);
			System.out.println("listening on port "+port);
			while (true) {
				int s = selector.select();
				if (s==0) {
					Thread.sleep(1000);
					continue;
				}
				Iterator keys = selector.selectedKeys().iterator();
				while (keys.hasNext()) {
					SelectionKey key = (SelectionKey)keys.next();
					

					if (key.isAcceptable()) {
						System.out.println("Connecting");
						ServerSocketChannel ssc = (ServerSocketChannel) key.channel();
						//Thread myHandler = new Thread(new NIOHandler(ssc, ssc.accept()));
						//myHandler.start();
						pool.handleConnection(ssc,protocolName,timeout,System.currentTimeMillis()+life);
						keys.remove();
						continue;
					}
				}

			}
			
		} catch (IOException e) {
			e.printStackTrace();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		
	}


	public static void main(String[] args) {
		NIOServer server = new NIOServer(9000,10,"127.0.0.1", "SMTP", 9000000, 90000000);
		Thread t = new Thread(server);
		t.start();
	}
}

class NIOHandler implements Runnable {
	ServerSocketChannel ssc;
	ByteBuffer byteBuffer = ByteBuffer.wrap(new byte[1024]);
	private SocketChannel ioChannel;
	
	NIOHandler(ServerSocketChannel channel, SocketChannel ioChannel) {
		this.ssc = channel;
		this.ioChannel = ioChannel;
	}
	
	/**
	 * @param channel
	 * @throws IOException
	 */
	private void readData(SocketChannel channel) throws IOException {
		byteBuffer.clear();
		int bytes = channel.read(byteBuffer);
		
		if (bytes <= 0) {
			channel.close();
			return;
		}	
		byteBuffer.flip();
		int limit = byteBuffer.limit();
		byte[] data = byteBuffer.array();
		String str = new String(data,0,limit);
		System.out.println(str);
	}


	/* (non-Javadoc)
	 * @see java.lang.Runnable#run()
	 */
	public void run() {
		Selector selector;
		
		try {
			selector = Selector.open();
			ioChannel.configureBlocking(false);
			ioChannel.register(selector, SelectionKey.OP_READ);
			System.out.println("established readable connection");
			while (true) {
				int s = selector.select();
				if (s==0) {
					Thread.sleep(1000);
					continue;
				}
				Iterator keys = selector.selectedKeys().iterator();
				while (keys.hasNext()) {
					SelectionKey key = (SelectionKey)keys.next();
					if (key.isReadable()) {
						System.out.println("readable");
						readData((SocketChannel)key.channel());
						keys.remove();
						continue;
					}
				}
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InterruptedException e2) {
			e2.printStackTrace();
		}
	}
}