/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail;

/**
 * Request represents a command parsed off of an input stream.  This will need to be processed by the 
 * protocol.  Specific protocols will require specific instances with specific data associated.
 * @author Andrew C. Oliver
 */
public interface Request {

    /**
     * retrieve the protocol for this request
     * @return Protocol instance for this request
     */
	Protocol getProtocol();
	
	/**
	 * @return remote address of the user in "xxx.xxx.xxx.xxx" string format.
	 */
	String getRemoteAddr();
}
