/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail;

import java.io.IOException;
import java.net.Socket;
import java.nio.channels.ServerSocketChannel;

import org.jboss.system.ServiceMBean;

/**
 * TODO: put some comment here!!
 *
 * @author Andrew C. Oliver <acoliver ot jboss dat org>
 */
public interface ThreadPoolMBean extends ServiceMBean {

    void setInitial(int initial);

    int getInitial();

    /**
     * @return Returns the max.
     */
    int getMax();

    /**
     * @param max The max to set.
     */
    void setMax(int max);

    /**
     * @return Returns the min.
     */
    int getMin();

    /**
     * @param min The min to set.
     */
    void setMin(int min);

    /**
     * @return Returns the idleKeepAlive.
     */
    int getIdleKeepAlive();

    /**
     * @param idleKeepAlive The idleKeepAlive to set.
     */
    void setIdleKeepAlive(int idleKeepAlive);
    
    void handleConnection(Socket socket, String protocolName, long timeout, long life) throws InterruptedException;
	/**
	 * @param ssc
	 * @param protocolName
	 * @param timeout
	 * @param l
	 * @throws IOException 
	 */
	void handleConnection(ServerSocketChannel ssc, String protocolName, long timeout, long life) throws InterruptedException;  
}