/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.dev.prot;

import org.jboss.mail.dev.prot.inf.Conditional;
import org.jboss.mail.dev.prot.inf.ConditionalFactory;
import org.jboss.mail.dev.prot.inf.MutableConditional;

/**
 * basic composite conditional implementation
 * 
 * @author <a href='mailto:mikea@xoba.com'>mike andrews</a>
 */
public abstract class AbstractConditional implements MutableConditional {

    private Conditional[] conditions;
    private String status;

    public void addSubConditionals(ConditionalFactory[] factories) throws InstantiationException {
	conditions = new Conditional[factories.length];
	for (int i=0; i<conditions.length; i++) {
	    conditions[i] = factories[i].createConditional();
	}
    }

    protected Conditional[] getConditionals() {
	return conditions;
    }

    public void setStatus(String status) {
	this.status = status;
    }

    public String getStatus() {
	return status;
    }
}
