/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.dev.prot;

import org.jboss.mail.dev.prot.inf.Manager;
import org.jboss.mail.dev.prot.inf.MutableModule;

/** 
 * @author <a href='mailto:mikea@xoba.com'>mike andrews</a>
 */	
public abstract class AbstractModule implements MutableModule {

    protected Manager manager;
    protected String patternText, receivedText;
    protected String id;
    private String status;

    public void init(Manager manager) {
	this.manager = manager;
    }

    public Manager getManager() {
	return manager;
    }
    
    public String getId() {
	return id;
    }

    public void setId(String id) {
	if (id == null) throw new RuntimeException("can't set null id");
	this.id = id;
    }

    public void setStatus(String status) {
	this.status = status;
    }

    public String getStatus() {
	return status;
    }

    public void setPatternText(String patternText) {
	if (patternText == null) throw new RuntimeException("can't set null pattern text");
	this.patternText = patternText;
    }

    public void setReceivedText(String receivedText) {
	this.receivedText = receivedText;
    }
    
    public String getText() {
	return receivedText;
    }

    public String getPatternText() {
	return patternText;
    }

}
