/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.dev.prot;

import org.jboss.mail.dev.prot.inf.*;

/**
 * computes logical AND
 * @author <a href='mailto:mikea@xoba.com'>mike andrews</a>
 * 
 */
public class AndConditional extends AbstractConditional {

    /**
     * returns true if all of the subconditionals return true
     */
    public boolean getValue() {
	Conditional[] conditions = getConditionals();
	for (int i=0; i<conditions.length; i++) {
	    if (!conditions[i].getValue()) {
		setStatus(conditions[i].getStatus());
		return false;
	    }
	}
	return true;
    }
}
