/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.dev.prot;

import org.jboss.mail.dev.prot.inf.*;

import org.xml.sax.*;

import org.apache.log4j.*;

/**
 * main debugging class for protocol tester
 *
 * @author mike andrews
 */
public class Main {

    public static void main(String[] args) throws Exception {

	System.setErr(System.out);

	Logger root = Logger.getRootLogger();

	root.setLevel(Level.INFO);
	
	Logger logger = Logger.getLogger(Main.class);

	Script[] scripts = ScriptParser.parseXml(new InputSource("src/resources/prot/smtp-scripts.xml"));
	
	// execute each script in turn

	for (int i=0; i<scripts.length; i++) {
	    logger.info(scripts[i].getId() + ": " + scripts[i].getValue());
	    System.out.println("transcript:");
	    System.out.println(scripts[i].getManager().getTranscript());
	}
    }

}
