/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.dev.prot;

import org.jboss.mail.dev.prot.inf.*;

import org.w3c.dom.*;
import java.lang.reflect.*;

/** 
 * @author <a href='mailto:mikea@xoba.com'>mike andrews</a>
 */	
public class ManagerFactoryImpl implements ManagerFactory {

    private Element e;
    private String host;

    public ManagerFactoryImpl(Element e, String host) {
	this.e = e;
	this.host = host;
    }

    public Manager createManager() {
	try {
	    String className = e.getAttribute("class");
	    ClassLoader cl = Thread.currentThread().getContextClassLoader();
	    Class clazz = cl.loadClass(className);
	    Constructor cons = clazz.getConstructor(new Class[0]);
	    MutableManager manager = (MutableManager) cons.newInstance(new Object[0]);
	
	    manager.setId(e.getAttribute("id"));
	    manager.setPort(new Integer(e.getAttribute("default-port")).intValue());
	    manager.setHost(host);

	    Element[] moduleElements = XmlUtilities.getElementsWithName(e,"module");
	    for (int i=0; i<moduleElements.length; i++) {
		manager.addModuleFactory(ModuleFactoryBuilder.newModuleFactory(manager,moduleElements[i]));
	    }
	
	    return manager;
	} catch (Exception e) {
	    throw new RuntimeException(e);
	}
    }

}
