/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.dev.prot;

import org.jboss.mail.dev.prot.inf.*;

/**
 * computes logical NOT
 * @author <a href='mailto:mikea@xoba.com'>mike andrews</a>
 */
public class NotConditional extends AbstractConditional {

    /**
     * returns negative of sub-conditional
     */
    public boolean getValue() {
	Conditional[] conditions = getConditionals();
	if (conditions.length != 1) throw new IllegalStateException("NOT can only have one subelement");
	if (conditions[0].getValue()) {
	    setStatus(conditions[0].getStatus());
	    return false;
	} else {
	    return true;
	}
    }
}
