/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.dev.prot;

import org.jboss.mail.dev.prot.inf.*;

/**
 * computes logical OR
 * @author <a href='mailto:mikea@xoba.com'>mike andrews</a>
 */
public class OrConditional extends AbstractConditional {

    /**
     * returns true if any of the subconditionals returns true, testing them
     * in order.
     */
    public boolean getValue() {
	Conditional[] conditions = getConditionals();
	boolean truth = false;
	StringBuffer buf = new StringBuffer();
	for (int i=0; i<conditions.length && !truth; i++) {
	    truth = conditions[i].getValue();
	    if (!truth) buf.append(conditions[i].getStatus() + "; ");
	}
	if (!truth) setStatus(buf.toString());
	return truth;
    }

}
