/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.dev.prot;

import java.io.*;

import org.apache.log4j.*;

/** 
 * @author <a href='mailto:mikea@xoba.com'>mike andrews</a>
 */	
public class POPResponseCodeModule extends AbstractModule {

    private static final Logger logger = Logger.getLogger(SMTPResponseCodeModule.class);

    private Integer responseCode;
    private boolean gotten;
    private boolean value;

    public POPResponseCodeModule() { }

    /**
     * +OK is true, -ERR is false
     */
    public boolean getValue() {
	if (!gotten) {
	    try {
		String response = manager.getFromServer();
		gotten = true;
		if (response.startsWith("+OK")) {
		    value= true;
		} else {
		    value= false;
		}
	    } catch (IOException e) {
		value= false;
	    }
	} 

	return value;
	
    }

}
