/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.dev.prot;

import java.io.IOException;

/**
 * simple client module (better renamed to something more descriptive)
 * @author <a href='mailto:mikea@xoba.com'>mike andrews</a>
 */
public class PlainTextModule extends AbstractModule {

    private boolean sent = false;
    private boolean value = false;

    public PlainTextModule() {
    }

    public boolean getValue() {
	if (!sent) {
	    try {
		// actually, should only add \r\n if text doesn't already end in crlf
		getManager().sendToServer(linefeedFix(getPatternText()) + "\r\n");
		value = true;
		sent = true;
	    } catch (IOException e) {
		setStatus("problem sending text to server");
		value = false;
	    }
	}
	
	return value;
    }

    /**
     * NOTE: jboss-mail seems intolerant of bodies without perfect \r\n linefeeds!!!! this is
     * non-robust behaviour.
     */
    public String linefeedFix(String text) {
	return text.replaceAll("[\\r\\n]+","\n").replaceAll("\\n","\r\n");
    }
    
}
