/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.dev.prot;

import java.io.*;

import org.apache.log4j.*;

/** 
 * @author <a href='mailto:mikea@xoba.com'>mike andrews</a>
 */	
public class SMTPResponseCodeModule extends AbstractModule {

    private static final Logger logger = Logger.getLogger(SMTPResponseCodeModule.class);

    private Integer responseCode;
    private boolean gotten;
    private boolean value;

    public SMTPResponseCodeModule() { }

    public Integer getResponseCode() {
	return new Integer(999);
    }

    public boolean getValue() {
	if (!gotten) {
	    try {
		String response = null;
		boolean done = false;
		while (!done) {
		    // read until end multiline response
		    response = manager.getFromServer();
		    logger.debug(response);
		    if (response.matches("^\\d\\d\\d .*$")) {
			done = true;
		    }
		}
		logger.debug("SMTPResponseCodeModule: " + response);
		gotten = true;
		if (response.startsWith(getPatternText())) {
		    value= true;
		} else {
		    value= false;
		}
	    } catch (IOException e) {
		value= false;
	    }
	} 

	return value;
	
    }

}
