/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.dev.prot;

import org.xml.sax.*;
import org.w3c.dom.*;
import java.io.*;
import javax.xml.parsers.*;

/** 
 * @author <a href='mailto:mikea@xoba.com'>mike andrews</a>
 */	
public class XmlUtilities {

    /**
     * gets all the text within an element (non-recursively)
     */
    public static String getElementText(Element e) {
	StringBuffer buf = new StringBuffer();
	NodeList list = e.getChildNodes();
	int length = list.getLength();
	for (int i=0; i<length; i++) {
	    Node child = list.item(i);
	    if (child.getNodeType() == Node.TEXT_NODE || child.getNodeType() == Node.CDATA_SECTION_NODE) {
		buf.append(child.getNodeValue());
	    }
	}
	return buf.toString();
    }

    public static Element[] getElementsWithName(Element e, String name) {
	NodeList list = e.getElementsByTagName(name);
	int n = list.getLength();
	Element[] elements = new Element[n];
	for (int i=0; i<n; i++) {
	    elements[i] = (Element) list.item(i);
	}
	return elements;
    }

    public static Document parse(InputSource source) throws IOException, SAXException {
	try {
	    DocumentBuilderFactory fact = DocumentBuilderFactory.newInstance();
	    DocumentBuilder builder = fact.newDocumentBuilder();
	    Document doc = builder.parse(source);

	    return doc;

	} catch (ParserConfigurationException e) {
	    throw new RuntimeException(e);
	}
    }

}
