/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.dev.prot.inf;

/**
 * an object that takes on a boolean value
 * @author <a href='mailto:mikea@xoba.com'>mike andrews</a>
 */
public interface Conditional {

    /**
     * gets the final value from the conditional, and triggers any processing required to 
     * establish the value if necessary. any triggered operations are only executed once, 
     * meaning the return value of 'getValue()' is constant over time.
     */
    public boolean getValue();

    /**
     * status information, which may contain error failure information, or null
     */
    public String getStatus();
}
