/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.dev.prot.inf;


/**
 * basic interface for a module. modules must follow javabeans pattern for xml declared fields.
 * after the getValue() method is called, javabeans methods may be called. module is responsible
 * for interacting with its manager in order to communicate with server
 *
 * @author mike andrews
 */
public interface Module extends Conditional {

    /**
     * the pattern of text that this module was configured with
     */
    public String getPatternText();

    /**
     * the unique id of the module type within the test suite
     */
    public String getId();

    /**
     * every module incorporates a manager
     */
    public Manager getManager();

}
