/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.dev.prot.inf;


/**
 * basic interface for a module. modules must also follow javabeans pattern for xml declared fields.
 * after the getSuccess() method is called, javabeans methods may be called
 *
 * @author mike andrews
 */
public interface MutableModule extends Module {

    /**
     * called right after construction.
     *
     * @param manager the manager this module will work under
     * @param declaredFields the set of fields the manager is interested in
     */
    public void init(Manager manager);

    public void setId(String id);

    public void setPatternText(String patternText);

    public void setReceivedText(String receivedText);
}
