/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.mailbox;

import org.jboss.system.ServiceMBean;

/**
 * Service interface for the Mailbox MBean.  The mailbox
 * provides the interface to local user's stored email.  All
 * incoming and outgoing mail for local users is stored/accessed
 * through this service.
 *
 * @author Eric Daugherty
 */
public interface MailboxMBean extends ServiceMBean {

    void setImplementationClass( String implementationClassName ) throws Exception;

    MailboxManager getMailboxManagerInstance();

}
