package org.jboss.mail.mailbox;

/**
 * Defines the interface that individual Mailbox implementations
 * will implement to plugin to JBoss Mail Services.
 *
 * @author Eric Daugherty
 */
public interface MailboxManager {

    /**
     * Provides access to an individual user's mailbox.  The caller
     * is responsible for locking the folder.
     *
     * @param username the username to use to lookup the mailbox.
     * @return the user's ROOT folder, or null if the user is not found.
     */
    Folder getMailbox( String username );
}
