package org.jboss.mail.mailbox.entity;

import org.jboss.mail.mailbox.Folder;
import org.jboss.mail.mailbox.MailboxManager;
import org.apache.log4j.Logger;

/**
 * Provide a MailboxManager implementation that uses Entity
 * beans to store Messages.
 *
 * @author Eric Daugherty
 */
public class EntityMailbox implements MailboxManager {

    /** Log4j logger */
    private static final Logger log = Logger.getLogger( EntityMailbox.class );

    /**
     * Provides access to an individual user's mailbox.  The caller
     * is responsible for locking the folder.
     *
     * @param username the username to use to lookup the mailbox.
     * @return the user's ROOT folder, or null if the user is not found.
     */
    public Folder getMailbox(String username) {

        return new EntityFolder( username );
    }
}
