package org.jboss.mail.mailbox.entity;

import javax.ejb.RemoveException;
import javax.ejb.EJBException;

import org.jboss.mail.mailbox.MailboxMessage;
import org.jboss.mail.mailbox.SimpleMailboxMessage;
import org.jboss.mail.mailbox.entity.message.LocalMessage;
import org.apache.log4j.Logger;

public class EntityMessage extends SimpleMailboxMessage implements MailboxMessage {

    private LocalMessage messageBean;

    /** Log4j logger */
    private static final Logger log = Logger.getLogger( EntityMessage.class );

    /**
     * Creates a new EntityMessage implementation from the Message Entity Bean.
     *
     * @param messageBean Entity Bean instance.
     */
/*
    public EntityMessage( LocalMessage messageBean )
    {
        this( messageBean.getId(), messageBean.getHeaders(), messageBean.getBody() );
        this.messageBean = messageBean;

        if( log.isDebugEnabled() ) log.debug( "EntityMessage Loaded from Entity MessageEJB " + messageBean.getId());
    }
*/

    public EntityMessage( String id, String headers, String body ) {
        super( id );
        System.out.println("new EntityMessage called");
        String localheaders = headers;
        String localbody = body;
        if(localheaders == null) {
          localheaders = "";
        } 
        if(localbody == null) {
          localbody = "";
        }
        this.headers = localheaders.split( "\r\n" );
        this.body = localbody.split( "\r\n" );
    }

    public void setLocal(LocalMessage messageBean) {
       this.messageBean = messageBean;
    }

    public void delete()
    {
        if( log.isDebugEnabled() ) log.debug( "Deleting message: " + messageBean.getId() );
        try {
            messageBean.remove();
        }
        catch (RemoveException removeException) {
            log.error( "Unable to remove message: " + messageBean.getId() + " " + removeException, removeException);
        }
        catch (EJBException e) {
            e.printStackTrace();  //To change body of catch statement use Options | File Templates.
        }

    }
}
