/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
 
package org.jboss.mail.maillist;
/**
* Constants defining the properties that can be set in MailListProperties
* @author <a href="kabirkhan@bigfoot.com">Kabir Khan</a>
*/
public interface MailListPropertyConstants {
	//These have been kind of adapted from James
	
	/** Boolean property: Whether the reply-to address for all messages sent to this 
	 * list is set to the list address. Defaults to true*/
	public static final String REPLY_TO_LIST 			= "replyToList";
	
	/** String property: If set, this value is prepended to the subject line of all 
	 * messages sent to the list*/
	public static final String SUBJECT_PREFIX 			= "subjectPrefix";
	
	/** Boolean property: If a subjectprefix is set, this value determines whether the 
	 * prefix is bracketed before being prepended to the subject line. Defaults to true*/
	public static final String PREFIX_AUTO_BRACKETED 	= "prefixAutoBracketed";
	
	/** Boolean property: whether attachments are allowed in messages sent to this list. 
	 * Defaults to false*/
	public static final String ATTACHMENT_ALLOWED		= "attachmentAllowed";
	
	/** Boolean property: Whether only members of the list can send messages to this list. 
	 * Defaults to true */
	public static final String MEMBERS_ONLY				= "membersOnly";
}
