/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.maillist.entity;

import org.jboss.mail.ServiceProxyFactory;
import org.jboss.mail.maillist.MailListManager;
import org.jboss.mail.message.MailAddress;
import org.jboss.system.ServiceMBean;

/*** MBean interface for the Entity bean implementation of the MailListManager MBean
 * 
 * @author <a href="kabirkhan@bigfoot.com">Kabir Khan</a>
 */
public interface EntityMailListManagerMBean extends ServiceMBean, ServiceProxyFactory, MailListManager {
	
	/** Just here to do a basic test in-container via jmx-console.
	 * To be removed once we are able to test using junit
	 */
	void test();
	
	boolean createList(String listAddress, boolean reply_to_list, 
			                               String subject_prefix, 
			                               boolean prefix_auto_backed,
			                               boolean attachment_allowed, 
										   boolean members_only);

	void addMember(MailAddress listAddress, MailAddress memberAddress);
	void addMemeber(String listAddress, String memberAddress);
}

