/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.maillist.entity.bean;

import java.util.Set;

import javax.ejb.EJBLocalObject;
import javax.ejb.RemoveException;

import org.jboss.mail.maillist.MailListProperties;
import org.jboss.mail.maillist.entity.EntityMailList;

/**
 * @author <a href="kabirkhan@bigfoot.com">Kabir Khan</a>
 *
 */
public interface MailListLocal extends EJBLocalObject {

	/** The address of the list.
	 */
	String getListAddress();
	void setProperties(MailListProperties properties);
	EntityMailList getMailList();	
	Set getMembers();
	void addMember(MailListMemberLocal mailListMember);
	void removeMember(MailListMemberLocal mailListMember)throws RemoveException;


}
