/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.maillist.entity.bean;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.RemoveException;

/**
 * @author <a href="kabirkhan@bigfoot.com">Kabir Khan</a>
 *
 */
public abstract class MailListMemberBean implements EntityBean {
	
	/** Mail list this message belongs to
	 */
	public abstract void setListAddress(String listAddress);
	public abstract String getListAddress();

	/** Email address for member in list
	 */
	public abstract void setMemberEmail(String email);
	public abstract String getMemberEmail();
	
	public void ejbActivate() throws EJBException{}
	public void ejbLoad() throws EJBException{}
	public void ejbPassivate() throws EJBException{}
	public void ejbRemove()throws RemoveException, EJBException{}
	public void ejbStore() throws EJBException{}
	public void setEntityContext(EntityContext ctx)throws EJBException{}
	public void unsetEntityContext() throws EJBException{}

	
	public MailListMemberPK ejbCreate(String mailListAddress, String email)throws CreateException{
		setListAddress(mailListAddress);
		setMemberEmail(email);
		return null;
	}
	
	public void ejbPostCreate(String listAddress, String email)throws CreateException{
	}
	
}
