/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.maillist.entity.bean;

import javax.ejb.EJBLocalObject;

import org.jboss.mail.maillist.MailList;
import org.jboss.mail.maillist.MailListProperties;
import org.jboss.mail.message.MailAddress;

/**
 * @author <a href="kabirkhan@bigfoot.com">Kabir Khan</a>
 *
 */
public interface MailListSBLocal extends EJBLocalObject {
	
	boolean createList(MailAddress listAddress, MailListProperties properties);
	
	void deleteList(MailAddress listAddress);
	
	MailList findList(MailAddress listAddress);
	
	void addMember(MailAddress listAddress, MailAddress address);
	
	boolean isMember(MailAddress listAddress, MailAddress address);

	MailAddress[] getMembers(MailAddress listAddress);

	void removeMember(MailAddress listAddress, MailAddress address);

	void setProperties(MailAddress listAddress, MailListProperties properties);

	
}
