/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.pop3;

/**
 * POP3 Constants contains constants for use throughout, most classes will just implement this interface
 * and use them directly.
 * 
 * @author Kabir Khan
 */
public interface POP3Constants {
	//properties
	/**
	 * Server Name for use in Protocol.getProperty
	 */
	public final static String SERVER_NAME = "servername";
	
	/**
	 * returns the user repository for use in authentication/authorization use with Protocol.getProperty
	 */
	public final static String USER_REPOSITORY = "user-repository";

	/**
	 * determines if the use of the STARTTLS-Extension is required
	 */
	//public final static String REQUIRE_STARTTLS = "requireSTARTTLS";
	/**
	 * determnines id the client needs to pass a certificate during SSL-Handshake after STARTTLS
	 */
	public final static String REQUIRE_CLIENT_CERT = "requireClientCert";
	/**
	 * enable or don't enable TLS (different from requireSTARTTLS as it determines whether we'll even allow it)
	 */
	public static final String TLS_SUPPORT = "tls-enabled"; 
    
	/** 
	 * The socket factory to be used to create sockets used for TLS
	 */
	public static final String SSL_SOCKET_FACTORY = "SSL_SOCKET_FACTORY";

}
