/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */

package org.jboss.mail.pop3;

import org.jboss.mail.ServiceProxyFactory;
import org.w3c.dom.Element;

/**
 * POP3Protocol is used by clients to retrieve mail.
 *
 * @author Eric Daugherty
 */
public interface POP3ProtocolMBean extends ServiceProxyFactory
{
    /**
     * used by the XMBean stuff to set up our properties (see sample)
     * @param properties Element from JBoss
     */
    void setProperties(Element properties);

    /**
     * return the proeprties as a DOM object
     * @return Element containing our properties...
     */
    Element getProperties();
    
	/** Set the JAAS security domain to be used with server sockets that support SSL
	 * @param domainName The JNDI name of the security domain used with server sockets that support SSL
	 */
	public void setSecurityDomain(String domainName);

	/** Get the JAAS security domain to be used with server sockets that support SSL
	 * @return The JNDI name of the security domain used with server sockets that support SSL
	 */
	public String getSecurityDomain();
    
}
