/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.pop3.handlers;

/**
 * Defines all messages written to the client
 * during a POP3 session.
 *
 * //TODO: Refactor this into some common message store.
 */
public interface POP3UserMessages {

    /** Generic affirmative respone */
    String MESSAGE_OK = "+OK";

    /** Generic message for a system error */
    String MESSAGE_SERVICE_UNAVAILABLE = "-ERR Service Unavailable";

    /** Message written to the user when the current state prohibits the requested command */
    String MESSAGE_INVALID_STATE = "-ERR Command not allowed at this time";

    /** Message written to the user when a parameter is required but missing */
    String MESSAGE_ARGUMENT_MISSING = "-ERR This command requires a parameter.";

    /** Message written to the user when a parameter is invalid */
    String MESSAGE_ARGUMENT_INVALID = "-ERR The parameter is invalid.";

    /** Message written to the user when they passed in more arguments than expected */
    String MESSAGE_TOO_MANY_ARGUMENTS = "-ERR Too many parameters specified.";

    /** Message written to the user when the USER command is specified twice before the PASS */
    String MESSAGE_USER_ALREADY_SPECIFIED = "-ERR User already specified.";

    /** Message written to the user when the specified username is invalid */
    String MESSAGE_USER_INVALID = "-ERR Invalid user.";

    /** Message written to the user if they specifiy the PASS command before the USER command. */
    String MESSAGE_USER_REQUIRED_BEFORE_PASS = "-ERR USER command must be issued before PASS.";

    /** Message written to the user when the specified username is invalid */
    String MESSAGE_PASS_INVALID = "-ERR Invalid password.";

    /** Message written to the user when their login information failed */
    String MESSAGE_AUTH_FAILED = "-ERR Invalid username and/or password.";

    /** The user's mailbox is already locked by another client */
    String MESSAGE_MAILBOX_LOCKED = "-ERR Mailbox locked.";

    /** The messaged id specified is invalid */
    String MESSAGE_INVALID_MESSAGE_ID = "-ERR Unknown message.";

    /** The commit (mailbox update) failed.  Changes may not have been persisted */
    String MESSAGE_COMMIT_FAILED = "-ERR Mailbox update failed.";

    //TODO: refactor - its a constant but not a user message
    public final static String USER_REPOSITORY = "user-repository";
    public final static String USER = "USER";
}
