/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.smtp.handlers;

import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintWriter;

import org.jboss.logging.Logger;
import org.jboss.mail.Protocol;
import org.jboss.mail.smtp.SMTPConstants;
import org.jboss.mail.smtp.SMTPRequest;
import org.jboss.mail.smtp.SMTPResponse;

/**
 * EXPN command, recommended by <a href='http://www.faqs.org/ftp/rfc/pdf/rfc2821.txt.pdf'>rfc 2821</a>
 *
 * @author Kabir Khan
 */
public class CmdEXPN implements SMTPHandler, SMTPConstants {

    private static final Logger jblog = Logger.getLogger(CmdEXPN.class);
    public final static String COMMAND = "EXPN";

    public SMTPResponse handleRequest(OutputStream out, SMTPRequest request, Protocol protocol) throws IOException {
		jblog.debug("EXPN command handler called");
		SMTPResponse response = new SMTPResponse(request, out, protocol);
		PrintWriter writer = response.getWriter();
		writer.println("502-"+protocol.getProperty(SERVER_NAME)+ " EXPN not implemented");
		writer.flush();
		return response;
    }
}
