/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.smtp.handlers;

import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintWriter;

import org.jboss.logging.Logger;
import org.jboss.mail.Protocol;
import org.jboss.mail.smtp.SMTPConstants;
import org.jboss.mail.smtp.SMTPRequest;
import org.jboss.mail.smtp.SMTPResponse;


/**
 * The NOOP does...no operation!
 * 
 * @author Kabir Khan
 * @author Andrew C. Oliver <acoliver ot jboss dat org> - javadoc only
 */
public class CmdNOOP implements SMTPHandler, SMTPConstants
{
	public final static String COMMAND = "NOOP";
	private static final Logger jblog = Logger.getLogger(CmdNOOP.class);


	/* (non-Javadoc)
	 * @see org.jboss.mail.smtp.handlers.SMTPHandler#handleRequest(java.io.OutputStream, org.jboss.mail.smtp.SMTPRequest, org.jboss.mail.Protocol, org.jboss.mail.log.MailLog)
	 */
	public SMTPResponse handleRequest(
		OutputStream out,
		SMTPRequest request,
		Protocol protocol)
		throws IOException {
		jblog.debug("NOOP command handler called");

		SMTPResponse response = new SMTPResponse(request, out, protocol);
		PrintWriter writer = response.getWriter();
		
		writer.println("250 NOOP OK");
        
		writer.flush();
		return response;
	}

}

