/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.smtp.handlers;

import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintWriter;

import org.jboss.logging.Logger;
import org.jboss.mail.Protocol;
import org.jboss.mail.smtp.SMTPConstants;
import org.jboss.mail.smtp.SMTPRequest;
import org.jboss.mail.smtp.SMTPResponse;

/**
 * VRFY command, recommended by <a href='http://www.faqs.org/ftp/rfc/pdf/rfc2821.txt.pdf'>rfc 821</a>
 * 
 * @author <a href='mailto:mikea@xoba.com'>mike andrews</a>
 */
public class CmdVRFY implements SMTPHandler, SMTPConstants {

    private static final Logger jblog = Logger.getLogger(CmdVRFY.class);
    public final static String COMMAND = "VRFY";

    public SMTPResponse handleRequest(OutputStream out, SMTPRequest request, Protocol protocol) throws IOException {
		jblog.debug("VRFY command handler called");
		SMTPResponse response = new SMTPResponse(request, out, protocol);
		PrintWriter writer = response.getWriter();
		writer.println("502-"+protocol.getProperty(SERVER_NAME)+ " VRFY not implemented");
		writer.flush();
		return response;
    }
}
