/*
 * Created on 21-Apr-04
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.jboss.mail.smtp.sender;

import java.util.ArrayList;

import org.jboss.mail.message.MailAddress;

/**
 * @author Kab
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

public class SMTPResultImpl implements SMTPResult {
	private MailAddress address;
	private int status;

	SMTPResultImpl(MailAddress address, int status) {
		this.address = address;
		this.status = status;
	}

	/**
	 * @param address addresses whose domain could not be resolved
	 * @return An ArrayList containing SMTPResult entries for each address indicating that the domain could not be resolved
	 */
	static ArrayList getResolveDomainErrorForAll(MailAddress[] address) {
		return getSameResultForAll(address, STATUS_DOMAIN_NOT_RESOLVED);
	}

	/**
	 * @param address addresses that were sent OK
	 * @return An ArrayList containing SMTPResult entries for each address indicating that they were sent successully
	 */
	static ArrayList getOkForAll(MailAddress[] address) {
		return getSameResultForAll(address, STATUS_OK);
	}

	/**
	 * @param address addresses that could not be sent
	 * @return An ArrayList containing SMTPResult entries for each address indicating that they could not be sent
	 */
	static ArrayList getErrorForAll(MailAddress[] address) {
		return getSameResultForAll(address, STATUS_ERROR);
	}

	/**
	 * @param address addresses 
	 * @param status The send status for the adresses
	 * @return An ArrayList containing SMTPResult entries for each address with given status
	 */
	private static ArrayList getSameResultForAll(
		MailAddress[] address,
		int status) {
		ArrayList results = new ArrayList(address.length);

		for (int i = 0; i < address.length; i++) {
			results.add(new SMTPResultImpl(address[i], status));
		}

		return results;
	}
	/* (non-Javadoc)
	 * @see org.jboss.mail.smtp.sender.SMTPResult#getAddress()
	 */
	public MailAddress getAddress() {
		// TODO Auto-generated method stub
		return address;
	}

	/* (non-Javadoc)
	 * @see org.jboss.mail.smtp.sender.SMTPResult#getStatus()
	 */
	public int getStatus() {
		// TODO Auto-generated method stub
		return status;
	}

	/* (non-Javadoc)
	 * @see org.jboss.mail.smtp.sender.SMTPResult#isOk()
	 */
	public boolean isOk() {
		// TODO Auto-generated method stub
		return status == 1;
	}

}
