/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.userrepository;

import org.jboss.mail.ServiceProxy;
import java.io.Serializable;
import java.util.Map;

/**
 * Static User Repository Proxy - local side of the STaticUserRepository 
 * TODO: have communicate back via JMX to test rather than pass it over... (NOT SECURE BY ANY MEANS ATM)
 * @author Andrew C. Oliver
 */
public class StaticUserRepositoryProxy
    implements ServiceProxy, UserRepository, Serializable {

    private Map users;

    protected StaticUserRepositoryProxy(Map users) {
        this.users = users;
    }

    /* (non-Javadoc)
     * @see org.jboss.mail.userrepository.UserRepository#test(java.lang.String, java.lang.String)
     */
    public boolean test(String username, String password) {
        return ((String)users.get(username)) == null ? false : ((String)users.get(username)).equals(password);
    }

	/* (non-Javadoc)
	 * @see org.jboss.mail.userrepository.UserRepository#test(java.lang.String)
	 */
	public boolean test(String username) {
		return users.get(username) != null;
	}

}
