/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.userrepository;

import java.io.Serializable;

/**
 * Represents some authority on users which can verify a username and password
 * @author Andrew C. Oliver
 */
public interface UserRepository extends Serializable {
  
  /**
   * can this user get in
   * @param username of the user
   * @param password of the user
   * @return does he exist and is this the correct password
   */
  public boolean test(String username, String password);

  /**
   * Does the user exist
   * @param username of the user
   * @return does he exist
   */
  public boolean test(String username);
}
