package org.jboss.mail.util;

import java.text.DateFormat;
import java.util.Date;

import javax.mail.internet.MailDateFormat;

/**
 * This class is not constructable but contains all of the date functions used throughout
 */
public class DateUtil {
	
	static MailDateFormat mailDateFormat;
	static{
		 mailDateFormat = new MailDateFormat();
	}
	
	/**
	 * private constructor to prevent construction
	 */
	private DateUtil(){}
	/**
	 * This may have a bug, it needs to be tested outside of W Europe and the US.  I don't know how
	 * it would work abroad.  It is supposed to return a LONG INTERNET TIME whatever that means.
	 * @return date in "LONG INTERNET TIME"
	 */
	public static String longInternetDate() {
		Date date = new Date();
		DateFormat dformat = DateFormat.getDateInstance(DateFormat.LONG);
		DateFormat tformat = DateFormat.getTimeInstance(DateFormat.LONG);
		return dformat.format(date)+" " + tformat.format(date);
	}
	
	/**  
	 * @return Current date in "message header format", specified in RFC 2822
	 */
	public static String mailHeaderDate(){
		return mailDateFormat.format(new Date());
	}
	
}
