/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.util;

/**
 * Keyed Value Objects are for key,value pairs where we don't need an actual map...
 * @author Andrew C. Oliver
 */
public class KeyedValueObject implements KeyedValue {
    private String key;
    private Object value;
    
    /**
     * construct an immutable keyed value (use the KeyedValue interface to get at it)
     * @param key
     * @param value
     */
    public KeyedValueObject(String key, Object value) {
        this.key = key;
        this.value = value;
    }

    /* (non-Javadoc)
     * @see org.jboss.mail.util.KeyedValue#getValue()
     */
    public Object getValue() {
        return value;
    }

    /* (non-Javadoc)
     * @see org.jboss.mail.util.KeyedValue#getKey()
     */
    public String getKey() {
        return key;
    }

}
