/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.dev;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

import junit.framework.TestCase;

/**
 * Test the script parser itself.
 */
public class TestScriptParser extends TestCase {

	public static void main(String[] args) {
		junit.textui.TestRunner.run(TestScriptParser.class);
	}
	
	/**
	 * can we parse a basic script
	 * @throws Exception
	 */
	public void testParseScript() throws Exception {
		String script = 
			 "S: bla bla\n" +
			 "C: bla bla bla\n" +
			 "END\n"+
			 "S1: bla bla\n" +
			 "S2: no bla bla\n" +
			 "C: yes bla bla\n" +
			 "END\n"+
             "S1: bla da bling\n" +
			 "C1: bla da bling bling\n" +
			 "S2: bla da blingy bling\n"+
			 "C2: bla da blingy blingy bling\nEND\n";
		InputStream stream = new ByteArrayInputStream(script.getBytes());
		Condition[] groups = ScriptParser.parseScript(stream);
	}
	
	/**
	 * can we parse a script with multiple lines under a client response?
	 * @throws Exception
	 */
	public void testParseScriptMultiline() throws Exception {
		String script = 
			"S: bla bla\n" +
			"C: bla bla bla\n" +
			"END\n"+
			"S1: bla bla\n" +
			"S2: no bla bla\n" +
			"C: yes bla bla\n" +
			"bla bla bla\n" +
			".\n" +
			"END\n"+
			"S1: bla da bling\n" +
			"C1: bla da bling bling\n" +
			"S2: bla da blingy bling\n"+
			"C2: bla da blingy blingy bling\nEND\n";
		InputStream stream = new ByteArrayInputStream(script.getBytes());
		Condition[] groups = ScriptParser.parseScript(stream);
	}

}
