package org.jboss.mail.dev.prot;

import junit.framework.AssertionFailedError;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestResult;
import junit.framework.TestSuite;

import org.jboss.mail.Server;
import org.jboss.mail.dev.prot.inf.Script;
import org.xml.sax.InputSource;

/**
 * test the client script runner with a basic simple test script (has 'X' in classname simply
 * to allow easy filtering of this test in ant target... should get rid of 'X' soon).
 */
public class TestXScripts extends TestSuite {

    private Server server = null;
    private long[] concurrentresults;

    public TestXScripts(String name) {
	super(name);
	
    }

    public static Test suite() throws Exception {
	TestSuite suite = new TestXScripts("my test");
	Script[] scripts = ScriptParser.parseXml(new InputSource("src/resources/prot/smtp-scripts.xml"));
	for (int i=0; i<scripts.length; i++) {
	    suite.addTest(createTest(scripts[i]));
	}
	return suite;
    }

    /**
     * try to control what AssertionFailedError does...
     */
    public static class MyAssertionFailedError extends AssertionFailedError {

	private String msg;

	public MyAssertionFailedError(String msg) {
	    this.msg = msg;
	}

	public String getMessage() {
	    return msg;
	}

	public String toString() {
	    return msg;
	}
    }

    /**
     * creates a test for a script
     */
    public static Test createTest(final Script script) {
        return new TestCase() {
		public int countTestCases() {
		    return 1;
		}
		
		public String getName() {
		    return script.getId() + ": " + script.getDescription();
		}

		public void run(TestResult result) {
		    result.startTest(this);
		    if (!script.getValue()) {
			result.addFailure(this,new MyAssertionFailedError(script.getStatus()));
		    }
		    result.endTest(this);
		}
	    };
    }
    
}
