/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.maillistener;

import javax.management.MBeanServer;
import javax.management.ObjectName;

import org.jboss.mail.MailListener;
import org.jboss.mail.ServiceProxy;
import org.jboss.mail.message.Message;
import org.jboss.mail.util.JBMailJMXUtil;

/**
 * Sends a message via a passed into the constructor JMX service with a "send" function.
 *
 * @author Andrew C. Oliver
 */
public class SysOutMailListenerProxy implements ServiceProxy, MailListener {
    ObjectName on;
    MBeanServer srv;

    /**
     * constructor used by the MailListener mbean to pass in its ObjectNAme instance 
     * @param objectname of the calling mail listener (for a callback)
     */    
    public SysOutMailListenerProxy(ObjectName objectname) {
           srv = JBMailJMXUtil.locateJBoss();
           on = objectname;                    
    }

    /* (non-Javadoc)
     * @see org.jboss.mail.MailListener#send(org.jboss.mail.Message)
     */
    public Message send(Message msg) {
        try {
            srv.invoke(on,"send",new Object[] {msg},new String[]{"org.jboss.mail.Message"});
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        }
        //return true;
        return msg;
    }

}
