/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.smtp.handlers;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;

import org.jboss.mail.smtp.SMTPRequest;
import org.jboss.mail.smtp.SMTPResponse;

/**
 * test the CmdAUTH handler
 * @author Andrew C. Oliver
 */
public class TestCmdAUTH extends HandlerBase {

	/*
	 * @see HandlerBase#setUp()
	 */
    public TestCmdAUTH(String name){
        super(name);
    }

	protected void setUp() throws Exception {
		super.setUp();
		handler = new CmdAUTH();
	}


	/* (non-Javadoc)
	 * @see org.jboss.mail.smtp.handlers.HandlerBase#testHandleRequest()
	 */
	public void testHandleRequest() throws Exception {
		ByteArrayInputStream in = new ByteArrayInputStream("".getBytes());
		ByteArrayOutputStream out = new ByteArrayOutputStream();
		SMTPRequest request = createRequest("AUTH", in, new String[]{"PLAIN AGFjb2xpdmVyAHRlc3Q="});
		
		SMTPResponse response = this.handleRequest(out,request);
		String res = out.toString();
		System.out.println("res was "+res);
		
		assertTrue("resposne can't be null", response != null);
		String expected = "235 Authentication Successful";
		assertTrue("expected: "+expected+", got="+res.toString().trim(), 
				   expected.equals(res.toString().trim()));
	}

	public static void main(String[] args) {
	}
}
