/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.smtp.handlers;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;

import org.jboss.mail.smtp.SMTPRequest;
import org.jboss.mail.smtp.SMTPResponse;

/**
 * Tests the CmdEHLO handler
 * @author Andrew C. Oliver
 */
public class TestCmdEHLO extends HandlerBase {

    public TestCmdEHLO(String name){
        super(name);
    }

    public static void main(String[] args) {
        junit.textui.TestRunner.run(TestCmdEHLO.class);
    }

    /*
     * @see HandlerBase#setUp()
     */
    protected void setUp() throws Exception {
        super.setUp();
        handler = new CmdEHLO();
    }

    public void testHandleRequest() throws Exception {
        ByteArrayInputStream in = new ByteArrayInputStream("".getBytes());
        ByteArrayOutputStream out = new ByteArrayOutputStream();
        SMTPRequest request =
            createRequest("EHLO", in, new String[] { "localhost" });

        SMTPResponse response = this.handleRequest(out, request);
        String res = out.toString();
        System.out.println("res was " + res);
        assertTrue("resposne can't be null", response != null);
        String expected =
            "250-localhost Hello localhost (null)"+newline+"250 AUTH LOGIN PLAIN";        assertTrue(
            "expected: \n!" + expected + "!\n, got=\n!" + res.toString().trim()+"!\n",
            expected.equalsIgnoreCase(res.toString().trim()));
    }

    public void testInvalidHandleRequest() throws Exception {
        ByteArrayInputStream in = new ByteArrayInputStream("".getBytes());
        ByteArrayOutputStream out = new ByteArrayOutputStream();
        SMTPRequest request = createRequest("EHLO", in, new String[] {
        });

        SMTPResponse response = this.handleRequest(out, request);
        String res = out.toString();
        System.out.println("res was " + res);

        assertTrue("resposne can't be null", response != null);
        String expected = "501 Domain address required: EHLO";
        assertTrue(
            "expected: " + expected + ", got=" + res.toString().trim(),
            expected.equals(res.toString().trim()));
    }

}
