/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.smtp.handlers;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;

import org.jboss.mail.smtp.SMTPConstants;
import org.jboss.mail.smtp.SMTPRequest;
import org.jboss.mail.smtp.SMTPResponse;

/**
* Test the CmdEXPN handler
 * @author Kabir Khan
 */
public class TestCmdEXPN extends HandlerBase{

    public TestCmdEXPN(String name){
        super(name);
    }

    public static void main(String[] args) {
        junit.textui.TestRunner.run(TestCmdEXPN.class);
    }

    /*
     * @see HandlerBase#setUp()
     */
    protected void setUp() throws Exception {
        super.setUp();
        handler = new CmdEXPN();
    }
    

    /* (non-Javadoc)
     * @see org.jboss.mail.smtp.handlers.HandlerBase#testHandleRequest()
     */
	public void testHandleRequest() throws Exception {
		ByteArrayInputStream in = new ByteArrayInputStream("".getBytes());
		ByteArrayOutputStream out = new ByteArrayOutputStream();
		
		SMTPRequest request =
			createRequest("EXPN", in, new String[] {"should_put in something proper later"});
		
		super.setProtocolState(SMTPConstants.SERVER_NAME, "localhost");
		
		SMTPResponse response = this.handleRequest(out, request);
		String res = out.toString();
		
		assertTrue("response can't be null", response != null);
		String expected = "502-" + protocol.getProperty(SMTPConstants.SERVER_NAME) + " EXPN not implemented";
		System.out.println(expected + "; got:" + res.toString().trim());
		
		assertTrue(
			"expected: " + expected + ", got=" + res.toString().trim(),
			expected.equals(res.toString().trim()));
	}
}
