/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.smtp.handlers;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;

import org.jboss.mail.smtp.SMTPRequest;
import org.jboss.mail.smtp.SMTPResponse;

/**
 * Test the CmdRCPT handler
 * @author Kabir Khan
 */
public class TestCmdNOOP extends HandlerBase {

    public TestCmdNOOP(String name){
        super(name);
    }

    public static void main(String[] args) {
        junit.textui.TestRunner.run(TestCmdNOOP.class);
    }

    /*
     * @see HandlerBase#setUp()
     */
    protected void setUp() throws Exception {
        super.setUp();
        handler = new CmdNOOP();
    }

    /* (non-Javadoc)
     * @see org.jboss.mail.smtp.handlers.HandlerBase#testHandleRequest()
     */
	public void testHandleRequest() throws Exception {
		ByteArrayInputStream in = new ByteArrayInputStream("".getBytes());
		ByteArrayOutputStream out = new ByteArrayOutputStream();
		
		SMTPRequest request =
			createRequest("NOOP", in, new String[] {});
			
		SMTPResponse response = this.handleRequest(out, request);
		String res = out.toString();

		assertTrue("response can't be null", response != null);
		String expected = "250 NOOP OK";
		
		assertTrue(
			"expected: " + expected + ", got=" + res.toString().trim(),
			expected.equals(res.toString().trim()));
		System.out.println("testHandleRequest()- DONE");
	}

}
