/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.maillistener;

import org.jboss.mail.MailListener;
import org.jboss.mail.ServiceProxy;
import org.jboss.mail.ServiceProxyFactory;
import org.jboss.mail.message.Mail;
import org.jboss.mail.message.Message;
import org.jboss.system.ServiceMBeanSupport;

/**
 * JMSMailListener - proof of concept code which posts mails to queues or topics.  It has both 
 * onServer and offServer settings thus you can divide the processing up such that posts for users
 * in domains handled by this SMTP server are "onServer" and handled by one set of MDBeans and the 
 * others are handled by the offServer queue and processed seperately.  If you don't want them 
 * seperate, just set them both to the same queue.
 *
 * @author Andrew C. Oliver
 */
public class SysOutMailListener
    extends ServiceMBeanSupport
    implements SysOutMailListenerMBean, ServiceProxyFactory, MailListener {


    /* (non-Javadoc)
     * @see org.jboss.mail.ServiceProxyFactory#produceServiceProxy()
     */
    public ServiceProxy produceServiceProxy() {
//        try {Class clazz = Class.forName("org.jboss.mail.maillistener.JMXMailListenerProxy");
//        JMXMailListenerProxy proxy1 = (JMXMailListenerProxy)clazz.newInstance();} 
//        catch (Exception e) { e.printStackTrace();}
        SysOutMailListenerProxy proxy = new SysOutMailListenerProxy(this.getServiceName());
        return proxy;
    }

    public void startService() throws Exception {
  
    }
    
    public void stopService() throws Exception {
        
    }
 
 
  


    /* (non-Javadoc)
     * @see org.jboss.mail.MailListener#send(org.jboss.mail.Message)
     */
    public Message send(Message msg) {
        System.out.println("Send message called");
        Mail mail = (Mail)msg;
        System.out.println("from: "+mail.getFrom().toString());
        for (int i = 0; i < mail.getTo().length; i++) {
        	System.out.println("to: "+mail.getTo()[i]);
        }
        System.out.println(new String(mail.getBody()));
        //return true;
        return msg;
    }

}
