/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mail.maillistener;

import org.jboss.mail.ServiceProxy;
import org.jboss.mail.ServiceProxyFactory;
import org.jboss.mail.message.Message;
import org.jboss.system.ServiceMBean;

/**
 * Proof of concept implementation which deals with posting your mails to JMS..  See 
 * JMSMailListener for more info.  
 *
 * @author Andrew C. Oliver
 */
public interface SysOutMailListenerMBean extends ServiceMBean, ServiceProxyFactory {

    /*
     * non javadoc: see ServiceProxyFactory interface 
     */
    ServiceProxy produceServiceProxy();

    /**
     * actually send the message.  This is used by the JMXMailListenerProxy to ACTUALLY send the mail
     * @param msg mail to send (we'll have to cast it to Mail)
     */
    Message send(Message msg);
}


